	
.text

/*
 *      Vector table. This is used for initial platform startup.
 *      These vectors are to catch any un-intended traps.
 */

_vectors:

.long   0x00000000, _start
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault

.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault

.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault

.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault


/*
 *      The very last vector position is stolen to use as a version
 *      number for this boot code :-)
 */

_version:
.long   0x01000000

/*****************************************************************************/


/*
 *      This is the initial start up entry point.
 */

_start:
        nop
        move.w #0x2700,%sr
	
	/* Vector Base Register setup */
	move.l #_vectors,%d0
	move.c %d0,%VBR

	/* Register file setup */
	move.l #0x10000001,%d0
	move.c %d0,%MBAR

	/* SRAM setup */
	move.l #0x20000001,%d0
	move.c %d0,%RAMBAR0
	move.l #0x20001000,%sp
	
	/* Disable Cache */
	clr.l %d0
	move.c %d0,%CACR
	
	jmp start_main
		
_fault:
	jmp _fault
